<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>About</title>
    <link href="../style.css" rel="stylesheet" type="text/css" media="all">
    <?php include($_SERVER['DOCUMENT_ROOT'] . '/seasonal.php'); ?>
  </head>
  <body>
    <?php include($_SERVER['DOCUMENT_ROOT'] . '/nav.php'); ?>
    <h1>about me</h1>
    <h2 id="caption">helo</h2>
    <p><span title="General Kenobi!">Hello there!</span> I generally go by deep twisty (more on that later) or some variation of "isopod" or "bathynomus" on this here internet. (<?php echo file_get_contents($_SERVER['DOCUMENT_ROOT'] . '/pronouns.txt'); ?> pronouns :) ) I like to make stuff on the computer, like <a href="https://deeptwisty.bandcamp.com/">music</a>, or <a href="https://deeptwisty.com/art">art</a>, or this website. I've heard rumors calling me such things as "canadian", "autistic", and "incalculably talented". I cannot confirm or deny any of these allegations.</p>
    <h2>Links</h2>
    <table>
      <tr>
        <td><a href="mailto:webmaster@isopod.cool" rel="me">webmaster@isopod.cool</a></td>
        <td>Email</td>
      </tr>
      <tr>
        <td><a href="https://matrix.to/#/@w:isopod.zone" rel="me">@w:isopod.zone</a></td>
        <td>Matrix</td>
      </tr>
      <tr>
        <td><a href="https://signal.me/#eu/Q5Z321Fn6bCsLhj3kNwXxvSgAUmbFiVtx2F-oG0A9_Egl_uTUmNLLYHs1WwbUE4B" rel="me">isopod.97</a></td>
        <td>Signal</td>
      </tr>
      <tr>
        <td>bathynomus#5230</td>
        <td>Revolt</td>
      </tr>
      <tr>
        <td><a href="https://isopod.zone/@root" rel="me">@root@isopod.zone</a></td>
        <td>Fediverse</td>
      </tr>
      <tr>
        <td><a href="https://cohost.org/bathynomus" rel="me">@bathynomus</a></td>
        <td>Cohost</td>
      </tr>
      <tr><td><a href="https://tumblr.isopod.cool/" rel="me">@isopodhours</a></td><td>Tumblr</td></tr>
      <tr>
        <td><a href="https://www.youtube.com/@deeptwisty" rel="me">deep twisty</a></td>
        <td>Youtube for music</td>
      </tr>
      <tr>
        <td><a href="https://www.youtube.com/@isopodgaming" rel="me">isopod gaming</a></td>
        <td>Youtube for other stuff</td>
      </tr>
      <tr>
        <td><a href="https://www.twitch.tv/deeptwistygaming" rel="me">deeptwistygaming</a></td>
        <td>Twitch</td>
      </tr>
      <tr>
        <td><a href="https://deeptwisty.bandcamp.com/" rel="me">deeptwisty.bandcamp.com</a></td>
        <td>Bandcamp</td>
      </tr>
      <tr>
        <td><a href="https://deeptwisty.itch.io/" rel="me">deeptwisty.itch.io</a></td>
        <td>itch.io</td>
      </tr>
      <tr>
        <td><a href="https://ko-fi.com/deeptwisty" rel="me">deeptwisty</a></td>
        <td>Ko-fi</td>
      </tr>
      <tr>
        <td><a href="https://git.isopod.cool/root/" rel="me">git.isopod.cool/root</a></td>
        <td>Forgejo</td>
      </tr>
    </table>
    <h2>What's a "deep twisty"?</h2>
    <p>"deep twisty" is a pseudonym I came up with to post my music and such things under. At this point it exists largely as a way to compartmentalize my online identity such that I can link my art to people who I might not want seeing all this. It comes from some tweets from an <a href="https://web.archive.org/web/20221214182955/https://twitter.com/SubnauticaSCM/status/1095774020446744576">official Subnautica twitter account</a> where they referred to the then-work-in-progress Deep Twisty Bridges biome as just "deep twisty". I thought it sounded funny. Funny enough to brand myself based on, apparently.</p>
    <h2>About the site</h2>
    <p>This website is written in pure HTML, CSS, and a tiny bit of Javascript with the server-side stuff done in PHP. It (and everything else I host) is hosted using Nginx on a VPS with 4GB of RAM and 2 CPU cores running Ubuntu Server, with domains registered with <a href="https://porkbun.com/">Porkbun</a>. You can read about its history <a href="../blog/posts/deeptwistycom_2nd_anniversary_-_a_history_of_this_bullshit/">here</a>.</p>
    <p>I was helped immensely in building this thing by <a href="https://www.w3schools.com/">W3Schools</a>, the <a href="https://developer.mozilla.org/en-US/docs/Web">MDN Web Docs</a>, the official <a href="https://www.php.net/manual/en/">PHP manual</a>, <a href="https://landchad.net/">LandChad.net</a>, Stack Overflow, and whatever disgusting bottom-feeding SEO leech sites came up first in the search results.</p>
    <h2>Testimonials</h2>
    <blockquote>"Most of it goes over my head, but it's still fun to read and look at, and I am not immune to isopods."<span class="attr">-<a href="https://kalechips.net/">Kalechips</a></span></blockquote>
    <blockquote>"Furry behavior"<span class="attr">-<a href="https://seaslug.neocities.org/">Seaslug</a></span></blockquote>
    <blockquote>"fuxk"<span class="attr">-f</span></blockquote>
    <blockquote>isopod isopod isopod isopod isopod isopod isopod isopod isopod<span class="attr">-Twiggy</span></blockquote>
    <div id="rightsidebg" style="background-image: url(bg.jxl), url(bg.jpg); --distancefromcenter: -10%;" title="Pictured: Me on my daily walk"></div>
  </body>
</html>
